package it.unina.instrumented.korel.days;


/**
 * classe che fornisce la "funzione days" da testare
 * 
 * @author francesco
 * 
 */
public class Days {
	private Integer numTestRequirements = 4;
	private Double[] korelValues = new Double[2 * numTestRequirements];
	private Boolean[] isReached = new Boolean[numTestRequirements];

	public Double[] getKorelValues() {
		return korelValues;
	}
	
	public Boolean[] getIsReached() {
		return isReached;
	}

	/**
	 * funzione che calcola i giorni che intercorrono tra due date dello stesso
	 * anno.
	 * 
	 * @param day1
	 * @param day2
	 * @param month1
	 * @param month2
	 * @param year
	 * @return
	 */
	public int days(int day1, int day2, int month1, int month2, int year) {
		int days = 0;
		int[] daysin = new int[13]; // numero di giorni del mese siccome il
		// vettore inizia da 0 la grandezza è 13 per
		// poter numerare i mesi da 1 a 12
		korelValues[0] = KorelFunction.korelFunction(month2, month1,
				KorelFunction.EQUAL_OP);
		korelValues[1] = KorelFunction.korelFunction(month2, month1,
				KorelFunction.NOT_EQUAL_OP);
		
		if ((isReached[0] = (month2 == month1)) && (month2 == month1)) {
			days = day2 - day1;
		} else {
			daysin[1] = 31;
			daysin[3] = 31;
			daysin[4] = 30;
			daysin[5] = 31;
			daysin[6] = 30;
			daysin[7] = 31;
			daysin[8] = 31;
			daysin[9] = 30;
			daysin[10] = 31;
			daysin[11] = 30;
			daysin[12] = 31;
			
			korelValues[2] = KorelFunction.korelFunction((year % 4), 0,
					KorelFunction.NOT_EQUAL_OP);
			korelValues[3] = KorelFunction.korelFunction((year % 4), 0,
					KorelFunction.EQUAL_OP);
			korelValues[4] = KorelFunction.korelFunction((year % 100), 0,
					KorelFunction.EQUAL_OP);
			korelValues[5] = KorelFunction.korelFunction((year % 100), 0,
					KorelFunction.NOT_EQUAL_OP);
			korelValues[6] = KorelFunction.korelFunction((year % 400), 0,
					KorelFunction.NOT_EQUAL_OP);
			korelValues[7] = KorelFunction.korelFunction((year % 400), 0,
					KorelFunction.EQUAL_OP);
			if (
					((isReached[1] = ((year % 4) != 0))&& ((year % 4) != 0))
					||
					(
							((isReached[2] = ((year % 100) == 0)) && ((year % 100) == 0))
							&& 
							((isReached[3] = ((year % 400) != 0)) && ((year % 400) != 0))
					)
				)
				daysin[2] = 28;
			else
				daysin[2] = 29;

			try {

				days = day2 + daysin[month1] - day1;
				for (int i = month1 + 1; i < month2; i++)
					days = days + daysin[i];

			} catch (ArrayIndexOutOfBoundsException e) {
				return -1;
			}

		}
		return days;
	}
}
